'use strict';

exports['default'] = extractLocationInfo;

function extractLocationInfo(_ref) {
	var file = _ref.file;
	var line = _ref.line;
	var column = _ref.column;
	var message = _ref.message;
	var loc = _ref.loc;

	if (line === undefined && column === undefined && loc) {
		line = loc.line;
		column = loc.column;
	}

	var match = undefined;

	if (line === undefined) {
		if (match = /line (\d+)/.exec(message)) {
			line = +match[1];
		}
	}

	if (column === undefined) {
		if (match = /column (\d+)/.exec(message)) {
			column = +match[1];
		}
	}

	return { file: file, line: line, column: column };
}
//# sourceMappingURL=extractLocationInfo.js.map
