'use strict';

var path = require('path');
var sander = require('sander');
var mapSeries = require('promise-map-series');
var sorcery = require('sorcery');



exports['default'] = flattenSourcemaps;
var whitelist = { ".js": true, ".css": true };
function flattenSourcemaps(inputdir, outputdir, base, task) {
	return sander.lsr(inputdir).then(function (files) {
		var jsAndCss = files.filter(function (file) {
			return whitelist[path.extname(file)];
		});

		return mapSeries(jsAndCss, function (file) {
			return sorcery.load(path.resolve(inputdir, file)).then(function (chain) {
				if (chain) {
					return chain.write(path.resolve(outputdir, file), { base: base });
				}
			})["catch"](function (err) {
				task.emit("error", err);
			});
		});
	}).then(function () {
		return inputdir;
	});
}
//# sourceMappingURL=flattenSourcemaps.js.map
